using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MyNamespace
{
	/// <summary>
	///		HelpForm for PrimeSRcs
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class HelpForm : System.Windows.Forms.Form
	{
		private MainMenu mainMenuHelp;
		private MenuItem menuItem4;
		private MenuItem menuFile;
		private MenuItem menuPrintSetup;
		private MenuItem menuPrint;
		private MenuItem menuExit;
		private Label labelTitle;
		private RichTextBox richTextOut;
		private PrintDialog printDialogHelp;
		private System.Drawing.Printing.PrintDocument printDocumentHelp;
		private MenuItem menuPrintPreview;
		private StringReader stringReader;
		private PrintPreviewDialog printPreviewDialog;
		private Timer timerHelp;
		private IContainer components;

		public HelpForm()
		{
			InitializeComponent();

			helpTextOut = richTextOut;
			helpTextOut.Clear();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			RunForm.helpWidth = this.Width;
			RunForm.helpHeight = this.Height;
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HelpForm));
			this.mainMenuHelp = new System.Windows.Forms.MainMenu(this.components);
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuPrintSetup = new System.Windows.Forms.MenuItem();
			this.menuPrint = new System.Windows.Forms.MenuItem();
			this.menuPrintPreview = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.richTextOut = new System.Windows.Forms.RichTextBox();
			this.labelTitle = new System.Windows.Forms.Label();
			this.printDialogHelp = new System.Windows.Forms.PrintDialog();
			this.printDocumentHelp = new System.Drawing.Printing.PrintDocument();
			this.printPreviewDialog = new System.Windows.Forms.PrintPreviewDialog();
			this.timerHelp = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// mainMenuHelp
			// 
			this.mainMenuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuFile});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuPrintSetup,
            this.menuPrint,
            this.menuPrintPreview,
            this.menuItem4,
            this.menuExit});
			this.menuFile.Text = "&File";
			// 
			// menuPrintSetup
			// 
			this.menuPrintSetup.Index = 0;
			this.menuPrintSetup.Text = "P&rint Setup";
			this.menuPrintSetup.Click += new System.EventHandler(this.menuPrintSetup_Click);
			// 
			// menuPrint
			// 
			this.menuPrint.Index = 1;
			this.menuPrint.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.menuPrint.Text = "&Print...";
			this.menuPrint.Click += new System.EventHandler(this.menuPrint_Click);
			// 
			// menuPrintPreview
			// 
			this.menuPrintPreview.Index = 2;
			this.menuPrintPreview.Text = "Print Pre&view";
			this.menuPrintPreview.Click += new System.EventHandler(this.menuPrintPreview_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 3;
			this.menuItem4.Text = "-";
			// 
			// menuExit
			// 
			this.menuExit.Index = 4;
			this.menuExit.Text = "E&xit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// richTextOut
			// 
			this.richTextOut.BackColor = System.Drawing.SystemColors.Window;
			this.richTextOut.Font = new System.Drawing.Font("Courier New", 9.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.richTextOut.Location = new System.Drawing.Point(0, 35);
			this.richTextOut.Name = "richTextOut";
			this.richTextOut.ReadOnly = true;
			this.richTextOut.Size = new System.Drawing.Size(696, 428);
			this.richTextOut.TabIndex = 0;
			this.richTextOut.Text = "";
			this.richTextOut.KeyDown += new System.Windows.Forms.KeyEventHandler(this.richTextOut_KeyDown);
			// 
			// labelTitle
			// 
			this.labelTitle.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelTitle.Location = new System.Drawing.Point(64, 8);
			this.labelTitle.Name = "labelTitle";
			this.labelTitle.Size = new System.Drawing.Size(416, 23);
			this.labelTitle.TabIndex = 1;
			this.labelTitle.Text = "<App.Title> Help Form";
			// 
			// printDocumentHelp
			// 
			this.printDocumentHelp.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocumentHelp_PrintPage);
			// 
			// printPreviewDialog
			// 
			this.printPreviewDialog.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.ClientSize = new System.Drawing.Size(792, 677);
			this.printPreviewDialog.Enabled = true;
			this.printPreviewDialog.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog.Icon")));
			this.printPreviewDialog.MaximizeBox = false;
			this.printPreviewDialog.Name = "printPreviewDialog";
			this.printPreviewDialog.Visible = false;
			// 
			// timerHelp
			// 
			this.timerHelp.Enabled = true;
			this.timerHelp.Interval = 500;
			this.timerHelp.Tick += new System.EventHandler(this.timerHelp_Tick);
			// 
			// HelpForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(690, 409);
			this.Controls.Add(this.labelTitle);
			this.Controls.Add(this.richTextOut);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenuHelp;
			this.Name = "HelpForm";
			this.Text = "<App.Title> - Help";
			this.Resize += new System.EventHandler(this.HelpForm_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.HelpForm_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		public void Help() // -------- Begin Main program Help
		{
			if (Global.helpUp >= 3) { Dispose(true); return; } // allow at most 3 Help Forms up
			Global.helpUp++;
			this.Cursor = Cursors.Arrow;
			this.Text = Global.title + " - Help";
			labelTitle.Text = Global.title + " Help";
			HelpFile = Global.pName + "Help.txt";
			ReadHelp();
			helpTextOut.Select(0, 0);	// move cursor to top
			helpTextOut.Focus();		// and focus
			this.Width = RunForm.helpWidth;			// Resize the form
			this.Height = RunForm.helpHeight;
		}

		private void ReadHelp()
		{
			StreamReader readHelpFile = null;
			string line;
			try
			{
				helpTextOut.Text = "";					// clear text output window
				PLn("");
				PLn("Reading Help File: " + HelpFile);
				readHelpFile = new StreamReader(HelpFile); // open the file
				helpTextOut.Text = "";					// clear text output window again
				line = readHelpFile.ReadLine();			// read first line of file
				while (line != null)					// loop until end of file
				{
					PLn("  " + line);					// output a line of Help
					line = readHelpFile.ReadLine();		// read in next line
				}
				helpTextOut.Select(0, 0);				// move cursor to top
			}
			catch (Exception ex)
			{
				PLn("Exception: " + ex.Message); // file not found
			}
			finally
			{
				if (readHelpFile != null)
				{
					readHelpFile.Close(); // close the file
				}
			}
		}

		private void menuPrint_Click(object sender, System.EventArgs e)
		// read Help from the RichTextBox and print it
		{
			string stringText = this.helpTextOut.Text;
			stringReader = new StringReader(stringText);
			printDialogHelp.Document = printDocumentHelp;
			if (printDialogHelp.ShowDialog() == DialogResult.OK)
			{
				this.printDocumentHelp.Print();
			}
		}

		private void Prn(string st) // print string to textOut window
		{
			helpTextOut.AppendText(st);
		}

		private void PLn(string st) // print string ... and new line to textOut
		{
			Prn(st + "\n");
		}

		private void menuExit_Click(object sender, System.EventArgs e) // exit help
		{
			Global.helpUp--;
			Dispose(true);
		}

		private void menuPrintSetup_Click(object sender, System.EventArgs e) // show printer setup dialog
		{
			this.printDialogHelp.Document = this.printDocumentHelp;
			printDialogHelp.ShowDialog();
		}

		private void HelpForm_Resize(object sender, System.EventArgs e) // resize the help form
		{
			int jTop = labelTitle.Top + labelTitle.Height + 5;
			this.richTextOut.SetBounds(1, jTop, this.ClientRectangle.Width - 2, this.ClientRectangle.Height - jTop -1);
		}

		private void printDocumentHelp_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs ev)
		{
			float linesPerPage = 0;
			float yPosition = 0;
			int count = 0;
			float leftMargin = ev.MarginBounds.Left;
			float topMargin = ev.MarginBounds.Top;
			string line = null;
			Font printFont = this.helpTextOut.Font;
			SolidBrush myBrush = new SolidBrush(Color.Black);

			// work out the number of lines per page, using the MarginBounds.
			linesPerPage = ev.MarginBounds.Height / printFont.GetHeight(ev.Graphics);

			// iterate over the string using the StringReader, printing each line.
			while (count < linesPerPage && (line=stringReader.ReadLine()) != null)
			{
				// calculate the next line position based on
				// the height of the font according to the printing device
				yPosition = topMargin + (count * printFont.GetHeight(ev.Graphics));

				// draw the next line in the rich edit control
				ev.Graphics.DrawString(line, printFont, myBrush, leftMargin, yPosition, new StringFormat());
				count++;
			}

			// if there are more lines, print another page.
			if(line != null)
				ev.HasMorePages = true;
			else
			{
				ev.HasMorePages = false;						// end of print
				string stringText = helpTextOut.Text;			// prepare to print again
				stringReader = new StringReader(stringText);
			}

			myBrush.Dispose();
		}

		private void menuPrintPreview_Click(object sender, System.EventArgs e)
		{
			try
			{
				string stringText = helpTextOut.Text;
				stringReader = new StringReader(stringText);
				printPreviewDialog.Document = printDocumentHelp;
				printPreviewDialog.FormBorderStyle = FormBorderStyle.Fixed3D;
				printPreviewDialog.ShowDialog();
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void richTextOut_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape) // ESC key pressed so Exit Help
			{
				Global.helpUp--;
				Dispose(true);
			}
		}

		private void timerHelp_Tick(object sender, EventArgs e)
		{
			if (!Global.runFormUp)
			{
				Global.helpUp--;
				Dispose(true);
			}
		}

		private void HelpForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Global.helpUp--;
		}

		private readonly RichTextBox helpTextOut;
		private string HelpFile;	// file name of Help file
	}
}
